From 39fbfe63db5e534d3a533bff2e24a2faa1f9f005 Mon Sep 17 00:00:00 2001
From: Jactry Zeng <jactry92@gmail.com>
Date: Tue, 29 Jan 2013 22:21:36 +0800
Subject: add simplified chinese
To: wine-patches <wine-patches@winehq.org>
Reply-To: wine-devel <wine-devel@winehq.org>

---
 templates/zh_CN/.cvsignore                       |    2 +
 templates/zh_CN/about.template                   |   58 +++++++
 templates/zh_CN/download.template                |  199 ++++++++++++++++++++++
 templates/zh_CN/global/404.template              |   16 ++
 templates/zh_CN/global/google_analytics.template |   10 ++
 templates/zh_CN/global/lang_row.template         |    3 +
 templates/zh_CN/help.template                    |  101 +++++++++++
 templates/zh_CN/home.template                    |   90 ++++++++++
 templates/zh_CN/lang.template                    |   12 ++
 templates/zh_CN/news.template                    |   16 ++
 templates/zh_CN/news_row.template                |    5 +
 templates/zh_CN/search.template                  |   26 +++
 12 files changed, 538 insertions(+)
 create mode 100644 templates/zh_CN/.cvsignore
 create mode 100644 templates/zh_CN/about.template
 create mode 100644 templates/zh_CN/download.template
 create mode 100644 templates/zh_CN/global/404.template
 create mode 100644 templates/zh_CN/global/google_analytics.template
 create mode 100644 templates/zh_CN/global/lang_row.template
 create mode 100644 templates/zh_CN/help.template
 create mode 100644 templates/zh_CN/home.template
 create mode 100644 templates/zh_CN/lang.template
 create mode 100644 templates/zh_CN/news.template
 create mode 100644 templates/zh_CN/news_row.template
 create mode 100644 templates/zh_CN/search.template

diff --git a/templates/zh_CN/.cvsignore b/templates/zh_CN/.cvsignore
new file mode 100644
index 0000000..0ba44f6
--- /dev/null
+++ b/templates/zh_CN/.cvsignore
@@ -0,0 +1,2 @@
+docs
+winapi_stats.template
diff --git a/templates/zh_CN/about.template b/templates/zh_CN/about.template
new file mode 100644
index 0000000..e650460
--- /dev/null
+++ b/templates/zh_CN/about.template
@@ -0,0 +1,58 @@
+<!--TITLE:[关于Wine]-->
+<!--BLURB:[解释Wine 项目]-->
+
+<h1 class="title">关于Wine</h1>
+
+<p>Wine ("Wine Is Not an Emulator" 的首字母缩写) 是一个能够在多种如Linux,
+Mac OSX, & BSD 等POSIX-compliant 操作系统上运行Windows 应用的兼容层.
+Wine 不是像虚拟机或者模拟器一样模仿内部的Windows 逻辑, 而是將Windows API
+调用翻译成为动态的POSIX 调用, 免除了性能和其他一些行为的内存占用, 让你能够干净地集合Windows 应用到你的桌面.</p>
+
+<p>Wine 开始于1993年, 最初由Bob Amstadt 发起, 旨在寻求一种在Linux 上运行
+Windows 3.1 程序的办法. 很早开始, Wine 的开发领导权转移到了Alexandre Julliard
+手中, 他从很早开始就已经管理着这个项目. 多年以来, 随着Windows API 和应用为了适应新硬件及软件而不断演变, Wine 也一直不断发展来支持新的特性, 移植到更多其他系统,
+并且更加稳定, 提供着更好的用户体验. </p>
+
+<p>通过确立一个宏伟的目标, 在2008年项目到达v1.0 之前, Wine 一直稳健地持续了
+15年之久, 那是第一个稳定版. 多个版本以后, 虽然还有许多工作要做, 但今天Wine
+仍然在活跃地开发着. 大约有<a href="http://wiki.winehq.org/UsageStatistics" title="Wine Usage
+Statistics">数以百万人计的人们</a>使用Wine 在他们所选择的系统上运行Windows 软件.</p>
+
+<h3>开放源代码和用户驱动的</h3>
+
+<p>Wine 将会永远是<a href="http://www.winehq.org/license"
+title="Wine licensing">自由软件</a>. 大约一半的Wine 代码由志愿者编写,
+剩下部分由商业公司赞助, 特别是
+<a href="http://www.codeweavers.com/products/" title="CodeWeavers
+CrossOver Office">CodeWeavers</a>, 出售着一个Wine 的支持版本.</p>
+
+<p>Wine 也是高度依赖用户社区的. 用户自愿贡献时间在我们的<a href="http://appdb.winehq.org/" title="Wine Application
+Database">Application Database</a> 上分享技巧和他们程序的运行测试结果, 在我们的<a href="http://bugs.winehq.org/"
+title="Bugzilla">Bug-Tracker</a> 上撰写bug 报告提醒开发者问题所在, 或者在<a href="http://forums.winehq.org/" title="WineHQ Forums">论坛</a>上回复问题.
+</p>
+
+<h3>了解更多:</h3>
+
+<p><i>(Several of the following pages are currently being reworked and
+may not be up-to-date)</i></p>
+
+<ul>
+    <li><a href="http://wiki.winehq.org/ImportanceOfWine">Why Wine is so
+        Important</a>
+    </li>
+    <li><a href="http://wiki.winehq.org/Debunking_Wine_Myths">Common
+        Myths about Wine</a>
+    </li>
+    <li><a href="http://wiki.winehq.org/WineHistory">History of the Wine
+        Project</a>
+    </li>
+    <li><a href="http://wiki.winehq.org/ProjectOrganization">
+        Organization and Leadership</a>
+    </li>
+    <li><a href="http://wiki.winehq.org/WhosWho">Some Contributor Bios
+        </a>
+    </li>
+    <li><a href="http://wiki.winehq.org/Acknowledgements">Other
+        Acknowledgements</a>
+    </li>
+</ul>
diff --git a/templates/zh_CN/download.template b/templates/zh_CN/download.template
new file mode 100644
index 0000000..c60bf80
--- /dev/null
+++ b/templates/zh_CN/download.template
@@ -0,0 +1,199 @@
+<!--TITLE:[Wine 二进制下载]-->
+<!--BLURB:[在这里下载对应你喜欢的系统的Wine ]-->
+
+<h1 class="title">下载Wine </h1>
+
+<h2 style="margin-bottom: 10px;"><a name="crossover"></a>被支持的Wine </h2>
+
+<table border="0" cellpadding="5" cellspacing="1" bgcolor="#EFEFEF">
+
+  <tr>
+    <td align="center" bgcolor="black"><b><font color="white" class="small">产品</font></b></td>
+    <td align="center" bgcolor="black"><b><font color="white" class="small">描述</font></b></td>
+  </tr>
+
+  <tr>
+    <td align="center" bgcolor="#ffffff">
+      <a href="http://www.codeweavers.com/products/download_trial/">
+        <img src="{$root}/images/distro/crossover.png" 
+         width="50" height="50" alt="CrossOver Linux or Mac" border="0">
+      </a>
+    </td>
+    <td align="left" bgcolor="#ffffff">
+      <b><a href="http://www.codeweavers.com/products/">CrossOver</a></b>
+      是由<b><a href="http://www.codeweavers.com">CodeWeavers</a></b> 提供的一个经过打磨的Wine 版本. 
+      CrossOver 使得用户可以更容易地使用Wine 并且CodeWeavers 为其用户提供极佳的技术支持. 
+      所有CrossOver 的购买都被直接用于支持Wine 的开发者. 所以CrossOver 可谓一举两得, 既可以得到使用Wine 的帮助又可以支持支持Wine 项目. 
+      CodeWeavers 提供全功能的
+      <b><a href="http://www.codeweavers.com/products/download_trial/">CrossOver 试用版</a></b>.
+    </td>
+  </tr>
+</table>
+
+<p class="small" align="center">This endorsement is the primary recognition that CodeWeavers has
+requested in exchange for hosting the Wine web site.</p>
+  
+
+<h2 style="margin-bottom: 5px;"><a name="binary"></a>Wine 的二进制下载</h2>
+
+<table style="margin: 0 0 15px 0;" width="100%">
+<tr>
+  <td width="200">最新的稳定版: </td><td>Wine&nbsp;{$config_stable_release}</td>
+  <td rowspan="2" valign="top" style="padding-left: 20px; text-align: center;"><b>查看
+  <a href="http://wiki.winehq.org/HowTo">installation and configuration how-to</a> 
+  获取快速安装说明.</b></td>
+</tr>
+<tr>
+  <td>最新的开发版: </td><td>Wine&nbsp;{$config_master_release}</td>
+</tr>
+</table>
+
+<table border="0" cellpadding="5" cellspacing="1" bgcolor="#EFEFEF">
+
+  <tr>
+    <td align="center" bgcolor="black"><b><font color="white" class="small">系统</font></b></td>
+    <td align="center" bgcolor="black"><b><font color="white" class="small">注释</font></b></td>
+    <td align="center" bgcolor="black"><b><font color="white" class="small">维护者</font></b></td>
+  </tr>
+  
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="{$root}/download/ubuntu">
+      <img src="{$root}/images/distro/ubuntu.png" width="50" height="50" alt="Ubuntu linux" border="0"></a>
+    </td>
+    <td> <b><a href="{$root}/download/ubuntu">下载Ubuntu 安装包</a></b> 
+     - Ubuntu Oneiric (11.10), 和Precise (12.04) 的二进制和源码 .debs
+    <td><a href="mailto:scott@open-vote.org">Scott Ritchie</a></td>
+  </tr>
+
+   <tr bgcolor="#ffffff">
+    <td align=center><a href="{$root}/download/debian">
+      <img src="{$root}/images/distro/debian.png" width="50" height="50" alt="Debian Linux" border="0"></a>
+    </td>
+    <td> <b><a href="{$root}/download/debian">下载Debian 安装包</a></b> 
+     - Debian Sid 的二进制 .debs</td>
+    <td><a href="mailto:curan@debian.org">Kai Wasserbäch</a></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://fedoraproject.org/wiki/AndreasBierfert/Wine">
+      <img src="{$root}/images/distro/redhat.png" width="50" height="50" alt="Red Hat Linux" border="0"></a>
+    </td>
+    <td> <b><a href="http://fedoraproject.org/wiki/AndreasBierfert/Wine">下载Red Hat / CentOS / Fedora 安装包</a></b>
+        - Red Hat Enterprise Linux 5, 6; CentOS 5, 6; Fedora Linux 16, 17和兼容发行版的二进制及源码 .rpms. 
+        wine 的元包可以通过<tt>yum</tt> 来安装, 
+        运行 "<tt>$ yum install wine</tt>" 从EPEL / Fedora Extras / Fedora 的仓库获取. 
+         </td>
+    <td><a href="mailto:andreas.bierfert_at_lowlatency.de">Andreas Bierfert</a></td>
+  </tr>
+  
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://en.opensuse.org/Wine#Repositories">
+      <img src="{$root}/images/distro/suse.png" width="50" height="50" alt="SUSE Linux" border="0"></a>
+    </td>
+    <td> <b><a href="http://en.opensuse.org/Wine#Repositories">下载SUSE 安装包</a></b>
+         -  openSUSE 11.1, 11.2, 11.3, 11.4和SUSE Linux Enterprise 10和11的发行二进制和源码 .rpms 及每日快照 RPMs.<br>
+         旧版本安装包可以从<a href="http://sourceforge.net/project/showfiles.php?group_id=6241&amp;package_id=79444">SourceForge</a> 获取
+     </td>
+    <td><a href="mailto:meissner@suse.de">Marcus Meissner</a></td>
+  </tr>
+  
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://sourceforge.net/projects/wine/files/Mandriva%20Packages/">
+      <img src="{$root}/images/distro/mandriva.png" width="50" height="50" alt="Mandriva Linux" border="0"></a>
+    </td>
+    <td> <b><a href="http://sourceforge.net/projects/wine/files/Mandriva%20Packages/">下载Mandriva 安装包</a></b>
+         - Mandriva Linux 2008, 2009,和 2010的二进制 .rpms . 下载2010.2的安装包,如果你的Mandriva 是2010.2
+     发行版, e.g. 2010 Spring. 下载2010.0安装包当你的Mandriva 是2010的第一个发行.</td>
+    <td><a href="mailto:marco@mandrivaclub.nl">Marco Meijer</a></td>
+  </tr>
+  
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://sourceforge.net/project/showfiles.php?group_id=6241&amp;package_id=6301">
+      <img src="{$root}/images/distro/slackware.png" width="50" height="50" alt="Slackware linux" border="0"></a>
+    </td>
+    <td> <b><a href="http://sourceforge.net/projects/wine/files/Slackware Packages/">下载Slackware 安装包</a></b>
+         - 二进制txz (Slackware 14.0), 和tgz (支持旧版本)</td>
+    <td><a href="mailto:studiosg@giustetti.net">Simone Giustetti</a></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://www.freshports.org/emulators/wine/">
+      <img src="{$root}/images/distro/freebsd.png" width="50" height="54" alt="FreeBSD" border="0"></a>
+    </td>
+    <td> <b><a href="http://www.freshports.org/emulators/wine/">下载FreeBSD 安装包</a></b>
+         - FreeBSD 5.3或者更新的源</td>
+    <td><a href="mailto:gerald@pfeifer.com">Gerald Pfeifer</a></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://www.pbidir.com/bt/search/?str=wine&amp;search=Search">
+      <img src="{$root}/images/distro/pcbsd.png" width="50" height="50" alt="FreeBSD" border="0"></a>
+    </td>
+    <td> <b><a href="http://www.pbidir.com/bt/search/?str=wine&amp;search=Search">下载PC-BSD 安装包</a></b>
+         - PC-BSD 的二进制安装包.pbi (基于FreeBSD 的系统)</td>
+    <td><a href="mailto:kris@pcbsd.com">Kris Moore</a></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://www.sunfreepacks.com/">
+      <img src="{$root}/images/distro/solaris.png" width="50" height="50" alt="Solaris 10" border="0"></a>
+    </td>
+    <td> <b><a href="http://www.sunfreepacks.com/">下载Solaris 10, SXCE 安装包</a></b>
+        - Solaris 10和SXCE x86的ASwine, ASwine-SXCE 二进制安装包.pkg</td>
+    <td><a href="mailto:asyropoulos@yahoo.com">Apostolos Syropoulos</a></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://hub.opensolaris.org/bin/view/Community+Group+desktop/wine">
+      <img src="{$root}/images/distro/opensolaris.png" width="50" height="50" alt="OpenSolaris" border="0"></a>
+    </td>
+    <td> <b><a href="http://hub.opensolaris.org/bin/view/Community+Group+desktop/wine">下载OpenSolaris 安装包</a></b>
+        - OpenSolaris x86的二进制安装包.pkg </td>
+    <td><a href="mailto:asyropoulos@yahoo.com">Apostolos Syropoulos</a></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center"><a href="http://maemo.org/packages/view/wine/">
+      <img src="{$root}/images/distro/maemo.png" width="50" height="50" alt="Maemo" border="0"></a>
+    </td>
+    <td> <b><a href="http://maemo.org/packages/view/wine/">下载Maemo 安装包</a></b>
+        - Maemo x86和Maemo ARM 的二进制安装包.deb </td>
+    <td><a href="http://maemo.org/profile/view/onion/">Kaj-Michael Lang</a></td>
+  </tr>
+
+
+</table>
+
+
+<h2 style="margin-bottom: 10px;"><a name="binary"></a>第三方工具</h2>
+
+<p>有些时候一个经过定制的Wine 可以使一个应用工作, 但是这些修改由于某些原因不能被合并到Wine 当中. 为了帮助克服当前Wine 的不足之处, 终端用户使用第三方应用已经有很久的历史了.  这些第三方应用是完全不被Wine 开发者支持的, 但是你会发现它可能很有帮助.  得到更多相关信息, 可以查看我们关于第三方应用的<a href="http://wiki.winehq.org/ThirdPartyApplications">wiki 页面</a> .</p>
+
+<h2><a name="source"></a>Wine 的源码下载</h2>
+
+<table border="0" cellpadding="5" cellspacing="1" bgcolor="#EFEFEF">
+
+  <tr>
+    <td align="center" bgcolor="black"><b><font color="white" class="small">位置</font></b></td>
+    <td align="center" bgcolor="black"><b><font color="white" class="small">描述</font></b></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td> <a href="http://sourceforge.net/projects/wine/files/Source/" target="_blank">sourceforge.net</a></td>
+    <td> 我们的正式源码发布站点. </td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td> <a href="http://wiki.winehq.org/GitWine">source.winehq.org/git</a> </td>
+    <td> 获取最新的开发版本. </td>
+  </tr>
+  
+  <tr bgcolor="#ffffff">
+    <td><a href="http://ibiblio.org/pub/linux/system/emulators/wine/">ibiblio.org</a></td>
+    <td> 正式源码和文档包可选下载站点. </td>
+  </tr>
+  
+</table>
+
+<div style="margin: 10px; padding: 5px; border: 1px solid #C0C0C0; background-color: #F0F0F0;"><b>注意:</b> 查看<a href="http://wiki.winehq.org/Recommended_Packages">recommended packages</a> 获取配置和构建Wine 的帮助.</div>
+
diff --git a/templates/zh_CN/global/404.template b/templates/zh_CN/global/404.template
new file mode 100644
index 0000000..db497b3
--- /dev/null
+++ b/templates/zh_CN/global/404.template
@@ -0,0 +1,16 @@
+<!--TITLE:[404 Not Found]-->
+<!--BLURB:[Ooops... 你进入了一个我们还没有预料到的地方.]-->
+
+<h1 class="title">404 Not Found</h1>
+
+<p>
+    抱歉, 文档没有被找到. 请确认你的链接并再一次尝试. 
+</p>
+
+<hr>
+
+<p>
+    如果你从WineHQ.org 的页面上打开一个链接并出错跳转到这里来了,请在<a href="http://bugs.winehq.org/enter_bug.cgi?product=WineHQ.org">Bugzilla</a>
+    上报它. 
+</p>
+
diff --git a/templates/zh_CN/global/google_analytics.template b/templates/zh_CN/global/google_analytics.template
new file mode 100644
index 0000000..bd6624a
--- /dev/null
+++ b/templates/zh_CN/global/google_analytics.template
@@ -0,0 +1,10 @@
+    <script type="text/javascript">
+    var _gaq = _gaq || [];
+    _gaq.push(['_setAccount', '{$gcode}']);
+    _gaq.push(['_trackPageview']);
+    (function(){
+        var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
+        ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
+        var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
+    })();
+    </script>
diff --git a/templates/zh_CN/global/lang_row.template b/templates/zh_CN/global/lang_row.template
new file mode 100644
index 0000000..cb6c776
--- /dev/null
+++ b/templates/zh_CN/global/lang_row.template
@@ -0,0 +1,3 @@
+    <li style="background-image: url('{$root}/images/lang/{$lang}.png'); background-repeat: no-repeat; padding: 0 0 10px 40px;">
+        <a href="{$root}/lang/{$lang}">{$langFull}</a> &middot; {$langHelp}
+    </li>
diff --git a/templates/zh_CN/help.template b/templates/zh_CN/help.template
new file mode 100644
index 0000000..58dab90
--- /dev/null
+++ b/templates/zh_CN/help.template
@@ -0,0 +1,101 @@
+<!--TITLE:[获取帮助]-->
+<!--BLURB:[你的所有关于Wine 的问题的答案.]-->
+
+<h1 class="title">获取帮助</h1>
+
+<p>这里有多种在使用Wine 过程中获取帮助的途径.</p>
+
+<table border="0" cellpadding="10" cellspacing="1" bgcolor="#EFEFEF">
+
+  <tr>
+    <td align="center" bgcolor="black" class="small"><b style="color: #FFFFFF">选项</b></td>
+    <td align="center" bgcolor="black" class="small"><b style="color: #FFFFFF">关于这个帮助选项</b></td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="http://www.codeweavers.com"><img src="{$root}/images/paid.png"><br>支付费用</a>
+    </td>
+    <td valign="top">
+        <a href="http://www.codeweavers.com">CodeWeavers</a> 提供对Wine 的付费支持.
+    </td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="http://wiki.winehq.org/FAQ"><img src="{$root}/images/faq.png"><br>FAQ</a>
+    </td>
+    <td valign="top">
+        大多数问题能够通过浏览我们的
+        <a href="http://wiki.winehq.org/FAQ">FAQ</a> 快速找到答案. 
+	这是你首先应该看看的地方, 确认你的问题是否已经被回答过了.
+    </td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="{$root}/documentation"><img src="{$root}/images/docs.png"><br>文档</a>
+    </td>
+    <td valign="top">
+        我们推荐你阅读我们的在线 <a href="{$root}/site/documentation">文档</a>
+        来寻找你问题的答案. 同样有趣的是我们的
+        <a href="http://wiki.winehq.org/HowTo">HowTo</a> , 
+	上面包含着一些对首次使用的用户有用的信息.
+    </td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="http://wiki.winehq.org/"><img src="{$root}/images/moinmoin.png"><br>Wiki</a>
+    </td>
+    <td valign="top">
+        你也可以阅读我们的<a href="http://wiki.winehq.org/">Wiki</a> ,
+	看看能不能找到你问题的答案. 
+    </td>
+  </tr>
+  
+<tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="http://forums.winehq.org/"><img src="{$root}/images/forum.png"><br>论坛</a>
+    </td>
+    <td valign="top">
+        我们拥有一个基于 <a href="http://forums.winehq.org/">web</a>/<a href="{$root}/site/forums">email</a>  的Wine 用户社区,
+	在上面Wine 用户可以提问并彼此取得沟通. 
+        也许你还想探索作为社区重要构成部分的 <a href="{$root}/site/forums">邮件列表</a>.
+    </td>
+  </tr>
+
+  <tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="{$root}/irc"><img src="{$root}/images/irc.png"><br>IRC</a>
+    </td>
+    <td valign="top">
+    	你能在我们的
+        <a href="{$root}/irc">IRC 频道</a>通过在线聊天与Wine 社区取得联系.
+    </td>
+  </tr>
+  
+  <tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="http://appdb.winehq.org/"><img src="{$root}/images/appdb.png"><br>AppDB</a>
+    </td>
+    <td valign="top">
+        如果你想获得关于某一个程序的帮助, 我们的 <a href="http://appdb.winehq.org/">Application Database</a> 是个不错的地方. 
+    </td>
+  </tr>
+  
+  <tr bgcolor="#ffffff">
+    <td align="center" class="small">
+        <a href="http://bugs.winehq.org/"><img src="{$root}/images/bugs.png"><br>Bugzilla</a>
+    </td>
+    <td valign="top">
+        我们的 <a href="http://bugs.winehq.org/">Bugzilla Bug Tracker</a>
+	包含了所有我们已经解决和正在解决的议题.
+    </td>
+  </tr>
+  
+</table>
+
+<p>关于我们网站的问题或者发现拼写错误? 请联系我们的 <a href="mailto:web-admin@winehq.org">Web 团队</a>.</p>
+
+<p>&nbsp;</p>
diff --git a/templates/zh_CN/home.template b/templates/zh_CN/home.template
new file mode 100644
index 0000000..8fc643f
--- /dev/null
+++ b/templates/zh_CN/home.template
@@ -0,0 +1,90 @@
+<!--TITLE:[在Linux, BSD, Solaris 和Mac OS X 上运行Windows 应用]-->
+<!--BLURB:[在Linux, BSD, Solaris 和Mac OS X 上运行Windows 应用]-->
+<!--META_KEYWORDS:[windows, linux, macintosh, solaris, freebsd]-->
+<!--META_DESCRIPTION:[Open Source Software for running Windows applications on other operating systems.]-->
+<!--STYLE:[content_nobox]-->
+
+<div id="main_left">
+
+    <div class="content cornerround" style="padding: 15px 10px 20px 60px; height: 445px; overflow: auto;">
+        <div class="winehq_menu">
+
+            <div class="info" onClick="document.location='{$root}/about/';">
+              <div class="icon"></div>
+              <div class="text">
+                <div class="title"><a href="{$root}/about/">关于</a></div>
+                <div class="subtitle">了解Wine 项目.</div>
+              </div>
+            </div>
+
+            <div class="dl" onClick="document.location='{$root}/download/';">
+              <div class="icon"></div>
+              <div class="text">
+                <div class="title"><a href="{$root}/download/">下载</a></div>
+                <div class="subtitle">安装最新的 Wine.</div>
+              </div>
+            </div>
+
+            <div class="help" onClick="document.location='{$root}/help/';">
+              <div class="icon"></div>
+              <div class="text">
+                <div class="title"><a href="{$root}/help/">支持</a></div>
+                <div class="subtitle">获取帮助.</div>
+              </div>
+            </div>
+
+            <div class="devel" onClick="document.location='{$root}/devel/';">
+              <div class="icon"></div>
+              <div class="text">
+                <div class="title"><a href="{$root}/devel/">开发</a></div>
+                <div class="subtitle">成为Wine 开发者.</div>
+              </div>
+            </div>
+
+            <div class="donate" onClick="document.location='{$root}/donate/';">
+              <div class="icon"></div>
+              <div class="text">
+                <div class="title"><a href="{$root}/donate/">捐助</a></div>
+                <div class="subtitle">捐助Wine 项目.</div>
+              </div>
+            </div>
+
+        </div>
+    </div>
+
+</div>
+<div id="main_right">
+
+    <div class="content cornerround" style="padding: 10px; height: 85px; overflow: auto;">
+        <h3 class="title" style="margin: 0;">最新发布</h3>
+        <table style="margin: 7px 0 0 15px; border-spacing: 0; border: 0;">
+        <tr><td>稳定版:</td>
+        <td style="padding-left: 15px; padding-bottom: 2px;">
+            <b><a href="{$root}/announce/{$config_stable_release}">Wine&nbsp;{$config_stable_release}</a></b>
+            <span class="small">
+              (<a href="http://source.winehq.org/git/wine.git?a=shortlog;h=refs/tags/wine-{$config_stable_release}">shortlog</a>)
+            </span>
+        </td></tr>
+        <tr><td>开发版:</td>
+        <td style="padding-left: 15px;">
+            <b><a href="{$root}/announce/{$config_master_release}">Wine&nbsp;{$config_master_release}</a></b>
+            <span class="small">
+              (<a href="http://source.winehq.org/git/wine.git?a=shortlog;h=refs/tags/wine-{$config_master_release}">shortlog</a>)
+            </span>
+        </td></tr>
+        </table>
+    </div>
+
+    <div class="content cornerround" style="margin-top: 15px; padding: 10px 0px 10px 10px;">
+      <div style="height: 340px; overflow: auto; padding-right: 10px;">
+
+        <h3 class="title"><a href="{$root}/news/">新闻</a></h3>
+
+        <!--EXEC:[news?n=10]-->
+
+        <p><a href="{$root}/news/">更多新闻...</a></p>
+      </div>
+    </div>
+
+</div>
+
diff --git a/templates/zh_CN/lang.template b/templates/zh_CN/lang.template
new file mode 100644
index 0000000..e8bf916
--- /dev/null
+++ b/templates/zh_CN/lang.template
@@ -0,0 +1,12 @@
+<!--TITLE:[WineHQ - 选择你的语言]-->
+<!--BLURB:[WineHQ 是一个支持多种语言的网站]-->
+
+<!--EXEC:[language]-->
+
+<h1 class="title">{$langChange}</h1>
+
+<p><b>当前语言: </b> {$langCur}</p>
+
+<ul style="list-style: none; margin-left: 20px; padding: 0;">
+<!--EXEC:[language?cmd=list]-->
+</ul>
diff --git a/templates/zh_CN/news.template b/templates/zh_CN/news.template
new file mode 100644
index 0000000..c300690
--- /dev/null
+++ b/templates/zh_CN/news.template
@@ -0,0 +1,16 @@
+<!--TITLE:[新闻]-->
+<!--BLURB:[来自Wine 社区的最新消息.]-->
+
+<h1 class="title">新闻</h1>
+
+<!--EXEC:[news]-->
+
+<hr />
+
+<div class="link-container">
+    <p><a href="{$root}/wwn/">World Wine News Archive</a></p>
+</div>
+<ul class="rss">
+    <li><a href="{$root}/news/rss/">WineHQ News RSS Feed</a></li>
+</ul>
+
diff --git a/templates/zh_CN/news_row.template b/templates/zh_CN/news_row.template
new file mode 100644
index 0000000..f6e0e84
--- /dev/null
+++ b/templates/zh_CN/news_row.template
@@ -0,0 +1,5 @@
+<p class="newstitle">{$title}</p>
+<p class="newsdate">{$date}</p>
+<div class="newsblock">
+{$body}
+</div>
diff --git a/templates/zh_CN/search.template b/templates/zh_CN/search.template
new file mode 100644
index 0000000..f950cb7
--- /dev/null
+++ b/templates/zh_CN/search.template
@@ -0,0 +1,26 @@
+<!--TITLE:[搜索结果]-->
+<!--BLURB:[winehq.org 全站搜索...]-->
+
+<h1 class="title" style="margin-bottom: 10px;">搜索结果</h1>
+
+<div id="cse-search-results"></div>
+<script type="text/javascript">
+  $.gglclientCoords = function() {
+     var dimensions = {width: 0, height: 0};
+     if (document.documentElement) {
+         dimensions.width = document.documentElement.offsetWidth;
+         dimensions.height = document.documentElement.offsetHeight;
+     } else if (window.innerWidth && window.innerHeight) {
+         dimensions.width = window.innerWidth;
+         dimensions.height = window.innerHeight;
+     }
+     return dimensions;
+  }
+  var googleSearchIframeName = "cse-search-results";
+  var googleSearchFormName = "cse-search-box";
+  var googleSearchFrameWidth = ($.gglclientCoords().width - 250);
+  var googleSearchDomain = "www.google.com";
+  var googleSearchPath = "/cse";
+</script>
+<script type="text/javascript" src="http://www.google.com/afsonline/show_afs_search.js"></script>
+
-- 
1.7.10.4