From 42cb7eef9b5552a12b8e6609d6ca39a3b7ba0ae7 Mon Sep 17 00:00:00 2001
From: Austin English <austinenglish@gmail.com>
Date: Tue, 26 Jun 2018 16:09:22 -0700
Subject: [PATCH] configure.ac: use -Wno-unused-command-line-argument if
 supported

This avoided ~9000 warnings on clang 6.x like:
clang-6.0: warning: argument unused during compilation: '-I ../../../include' [-Wunused-command-line-argument]
clang-6.0: warning: argument unused during compilation: '-I ../../include' [-Wunused-command-line-argument]

Signed-off-by: Austin English <austinenglish@gmail.com>
---
 configure.ac | 1 +
 1 file changed, 1 insertion(+)

diff --git a/configure.ac b/configure.ac
index 9c38cfb..96d8702 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1899,6 +1899,7 @@ then
   WINE_TRY_CFLAGS([-Wdeclaration-after-statement])
   WINE_TRY_CFLAGS([-Wempty-body])
   WINE_TRY_CFLAGS([-Wignored-qualifiers])
+  WINE_TRY_CFLAGS([-Wno-unused-command-line-argument])
   WINE_TRY_CFLAGS([-Wpacked-not-aligned],[EXTRACFLAGS="$EXTRACFLAGS -Wno-packed-not-aligned"])
   WINE_TRY_CFLAGS([-Wpragma-pack],[EXTRACFLAGS="$EXTRACFLAGS -Wno-pragma-pack"])
   WINE_TRY_CFLAGS([-Wshift-overflow=2])
-- 
1.9.1